// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: solarmodule/solarmodule.proto

package openfmb.solarmodule;

/**
 * <pre>
 * Specialized 61850 ZGEN class
 * </pre>
 *
 * Protobuf type {@code solarmodule.SolarEventAndStatusZGEN}
 */
public final class SolarEventAndStatusZGEN extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:solarmodule.SolarEventAndStatusZGEN)
    SolarEventAndStatusZGENOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SolarEventAndStatusZGEN.newBuilder() to construct.
  private SolarEventAndStatusZGEN(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SolarEventAndStatusZGEN() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SolarEventAndStatusZGEN();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEventAndStatusZGEN_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEventAndStatusZGEN_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.solarmodule.SolarEventAndStatusZGEN.class, openfmb.solarmodule.SolarEventAndStatusZGEN.Builder.class);
  }

  public static final int LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNodeForEventAndStatus field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNodeForEventAndStatus.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
    return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
  }

  public static final int AUXPWRST_FIELD_NUMBER = 2;
  private openfmb.commonmodule.StatusSPS auxPwrSt_;
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
   * @return Whether the auxPwrSt field is set.
   */
  @java.lang.Override
  public boolean hasAuxPwrSt() {
    return auxPwrSt_ != null;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
   * @return The auxPwrSt.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getAuxPwrSt() {
    return auxPwrSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getAuxPwrStOrBuilder() {
    return auxPwrSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
  }

  public static final int DYNAMICTEST_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ENS_DynamicTestKind dynamicTest_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
   * @return Whether the dynamicTest field is set.
   */
  @java.lang.Override
  public boolean hasDynamicTest() {
    return dynamicTest_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
   * @return The dynamicTest.
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_DynamicTestKind getDynamicTest() {
    return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ENS_DynamicTestKindOrBuilder getDynamicTestOrBuilder() {
    return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
  }

  public static final int EMGSTOP_FIELD_NUMBER = 4;
  private openfmb.commonmodule.StatusSPS emgStop_;
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
   * @return Whether the emgStop field is set.
   */
  @java.lang.Override
  public boolean hasEmgStop() {
    return emgStop_ != null;
  }
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
   * @return The emgStop.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getEmgStop() {
    return emgStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
  }
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getEmgStopOrBuilder() {
    return emgStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
  }

  public static final int POINTSTATUS_FIELD_NUMBER = 5;
  private openfmb.solarmodule.SolarPointStatus pointStatus_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
   * @return Whether the pointStatus field is set.
   */
  @java.lang.Override
  public boolean hasPointStatus() {
    return pointStatus_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
   * @return The pointStatus.
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarPointStatus getPointStatus() {
    return pointStatus_ == null ? openfmb.solarmodule.SolarPointStatus.getDefaultInstance() : pointStatus_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarPointStatusOrBuilder getPointStatusOrBuilder() {
    return pointStatus_ == null ? openfmb.solarmodule.SolarPointStatus.getDefaultInstance() : pointStatus_;
  }

  public static final int ALRM_FIELD_NUMBER = 6;
  private openfmb.commonmodule.Optional_AlrmKind alrm_;
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
   * @return Whether the alrm field is set.
   */
  @java.lang.Override
  public boolean hasAlrm() {
    return alrm_ != null;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
   * @return The alrm.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_AlrmKind getAlrm() {
    return alrm_ == null ? openfmb.commonmodule.Optional_AlrmKind.getDefaultInstance() : alrm_;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_AlrmKindOrBuilder getAlrmOrBuilder() {
    return alrm_ == null ? openfmb.commonmodule.Optional_AlrmKind.getDefaultInstance() : alrm_;
  }

  public static final int GNSYNST_FIELD_NUMBER = 7;
  private openfmb.commonmodule.StatusSPS gnSynSt_;
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
   * @return Whether the gnSynSt field is set.
   */
  @java.lang.Override
  public boolean hasGnSynSt() {
    return gnSynSt_ != null;
  }
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
   * @return The gnSynSt.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getGnSynSt() {
    return gnSynSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
  }
  /**
   * <pre>
   * Emergency stop
   * </pre>
   *
   * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getGnSynStOrBuilder() {
    return gnSynSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
  }

  public static final int GRIDCONNECTIONSTATE_FIELD_NUMBER = 8;
  private openfmb.commonmodule.Optional_GridConnectionStateKind gridConnectionState_;
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
   * @return Whether the gridConnectionState field is set.
   */
  @java.lang.Override
  public boolean hasGridConnectionState() {
    return gridConnectionState_ != null;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
   * @return The gridConnectionState.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_GridConnectionStateKind getGridConnectionState() {
    return gridConnectionState_ == null ? openfmb.commonmodule.Optional_GridConnectionStateKind.getDefaultInstance() : gridConnectionState_;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_GridConnectionStateKindOrBuilder getGridConnectionStateOrBuilder() {
    return gridConnectionState_ == null ? openfmb.commonmodule.Optional_GridConnectionStateKind.getDefaultInstance() : gridConnectionState_;
  }

  public static final int MANALRMINFO_FIELD_NUMBER = 9;
  private com.google.protobuf.StringValue manAlrmInfo_;
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
   * @return Whether the manAlrmInfo field is set.
   */
  @java.lang.Override
  public boolean hasManAlrmInfo() {
    return manAlrmInfo_ != null;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
   * @return The manAlrmInfo.
   */
  @java.lang.Override
  public com.google.protobuf.StringValue getManAlrmInfo() {
    return manAlrmInfo_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : manAlrmInfo_;
  }
  /**
   * <pre>
   * DC Power On/Off Status; True = DC power on
   * </pre>
   *
   * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
   */
  @java.lang.Override
  public com.google.protobuf.StringValueOrBuilder getManAlrmInfoOrBuilder() {
    return manAlrmInfo_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : manAlrmInfo_;
  }

  public static final int OPERATINGSTATE_FIELD_NUMBER = 10;
  private openfmb.commonmodule.Optional_OperatingStateKind operatingState_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
   * @return Whether the operatingState field is set.
   */
  @java.lang.Override
  public boolean hasOperatingState() {
    return operatingState_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
   * @return The operatingState.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_OperatingStateKind getOperatingState() {
    return operatingState_ == null ? openfmb.commonmodule.Optional_OperatingStateKind.getDefaultInstance() : operatingState_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_OperatingStateKindOrBuilder getOperatingStateOrBuilder() {
    return operatingState_ == null ? openfmb.commonmodule.Optional_OperatingStateKind.getDefaultInstance() : operatingState_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNodeForEventAndStatus_ != null) {
      output.writeMessage(1, getLogicalNodeForEventAndStatus());
    }
    if (auxPwrSt_ != null) {
      output.writeMessage(2, getAuxPwrSt());
    }
    if (dynamicTest_ != null) {
      output.writeMessage(3, getDynamicTest());
    }
    if (emgStop_ != null) {
      output.writeMessage(4, getEmgStop());
    }
    if (pointStatus_ != null) {
      output.writeMessage(5, getPointStatus());
    }
    if (alrm_ != null) {
      output.writeMessage(6, getAlrm());
    }
    if (gnSynSt_ != null) {
      output.writeMessage(7, getGnSynSt());
    }
    if (gridConnectionState_ != null) {
      output.writeMessage(8, getGridConnectionState());
    }
    if (manAlrmInfo_ != null) {
      output.writeMessage(9, getManAlrmInfo());
    }
    if (operatingState_ != null) {
      output.writeMessage(10, getOperatingState());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNodeForEventAndStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNodeForEventAndStatus());
    }
    if (auxPwrSt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getAuxPwrSt());
    }
    if (dynamicTest_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getDynamicTest());
    }
    if (emgStop_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getEmgStop());
    }
    if (pointStatus_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getPointStatus());
    }
    if (alrm_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getAlrm());
    }
    if (gnSynSt_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getGnSynSt());
    }
    if (gridConnectionState_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(8, getGridConnectionState());
    }
    if (manAlrmInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(9, getManAlrmInfo());
    }
    if (operatingState_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(10, getOperatingState());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.solarmodule.SolarEventAndStatusZGEN)) {
      return super.equals(obj);
    }
    openfmb.solarmodule.SolarEventAndStatusZGEN other = (openfmb.solarmodule.SolarEventAndStatusZGEN) obj;

    if (hasLogicalNodeForEventAndStatus() != other.hasLogicalNodeForEventAndStatus()) return false;
    if (hasLogicalNodeForEventAndStatus()) {
      if (!getLogicalNodeForEventAndStatus()
          .equals(other.getLogicalNodeForEventAndStatus())) return false;
    }
    if (hasAuxPwrSt() != other.hasAuxPwrSt()) return false;
    if (hasAuxPwrSt()) {
      if (!getAuxPwrSt()
          .equals(other.getAuxPwrSt())) return false;
    }
    if (hasDynamicTest() != other.hasDynamicTest()) return false;
    if (hasDynamicTest()) {
      if (!getDynamicTest()
          .equals(other.getDynamicTest())) return false;
    }
    if (hasEmgStop() != other.hasEmgStop()) return false;
    if (hasEmgStop()) {
      if (!getEmgStop()
          .equals(other.getEmgStop())) return false;
    }
    if (hasPointStatus() != other.hasPointStatus()) return false;
    if (hasPointStatus()) {
      if (!getPointStatus()
          .equals(other.getPointStatus())) return false;
    }
    if (hasAlrm() != other.hasAlrm()) return false;
    if (hasAlrm()) {
      if (!getAlrm()
          .equals(other.getAlrm())) return false;
    }
    if (hasGnSynSt() != other.hasGnSynSt()) return false;
    if (hasGnSynSt()) {
      if (!getGnSynSt()
          .equals(other.getGnSynSt())) return false;
    }
    if (hasGridConnectionState() != other.hasGridConnectionState()) return false;
    if (hasGridConnectionState()) {
      if (!getGridConnectionState()
          .equals(other.getGridConnectionState())) return false;
    }
    if (hasManAlrmInfo() != other.hasManAlrmInfo()) return false;
    if (hasManAlrmInfo()) {
      if (!getManAlrmInfo()
          .equals(other.getManAlrmInfo())) return false;
    }
    if (hasOperatingState() != other.hasOperatingState()) return false;
    if (hasOperatingState()) {
      if (!getOperatingState()
          .equals(other.getOperatingState())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNodeForEventAndStatus()) {
      hash = (37 * hash) + LOGICALNODEFOREVENTANDSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNodeForEventAndStatus().hashCode();
    }
    if (hasAuxPwrSt()) {
      hash = (37 * hash) + AUXPWRST_FIELD_NUMBER;
      hash = (53 * hash) + getAuxPwrSt().hashCode();
    }
    if (hasDynamicTest()) {
      hash = (37 * hash) + DYNAMICTEST_FIELD_NUMBER;
      hash = (53 * hash) + getDynamicTest().hashCode();
    }
    if (hasEmgStop()) {
      hash = (37 * hash) + EMGSTOP_FIELD_NUMBER;
      hash = (53 * hash) + getEmgStop().hashCode();
    }
    if (hasPointStatus()) {
      hash = (37 * hash) + POINTSTATUS_FIELD_NUMBER;
      hash = (53 * hash) + getPointStatus().hashCode();
    }
    if (hasAlrm()) {
      hash = (37 * hash) + ALRM_FIELD_NUMBER;
      hash = (53 * hash) + getAlrm().hashCode();
    }
    if (hasGnSynSt()) {
      hash = (37 * hash) + GNSYNST_FIELD_NUMBER;
      hash = (53 * hash) + getGnSynSt().hashCode();
    }
    if (hasGridConnectionState()) {
      hash = (37 * hash) + GRIDCONNECTIONSTATE_FIELD_NUMBER;
      hash = (53 * hash) + getGridConnectionState().hashCode();
    }
    if (hasManAlrmInfo()) {
      hash = (37 * hash) + MANALRMINFO_FIELD_NUMBER;
      hash = (53 * hash) + getManAlrmInfo().hashCode();
    }
    if (hasOperatingState()) {
      hash = (37 * hash) + OPERATINGSTATE_FIELD_NUMBER;
      hash = (53 * hash) + getOperatingState().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarEventAndStatusZGEN parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.solarmodule.SolarEventAndStatusZGEN prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Specialized 61850 ZGEN class
   * </pre>
   *
   * Protobuf type {@code solarmodule.SolarEventAndStatusZGEN}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:solarmodule.SolarEventAndStatusZGEN)
      openfmb.solarmodule.SolarEventAndStatusZGENOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEventAndStatusZGEN_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEventAndStatusZGEN_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.solarmodule.SolarEventAndStatusZGEN.class, openfmb.solarmodule.SolarEventAndStatusZGEN.Builder.class);
    }

    // Construct using openfmb.solarmodule.SolarEventAndStatusZGEN.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      auxPwrSt_ = null;
      if (auxPwrStBuilder_ != null) {
        auxPwrStBuilder_.dispose();
        auxPwrStBuilder_ = null;
      }
      dynamicTest_ = null;
      if (dynamicTestBuilder_ != null) {
        dynamicTestBuilder_.dispose();
        dynamicTestBuilder_ = null;
      }
      emgStop_ = null;
      if (emgStopBuilder_ != null) {
        emgStopBuilder_.dispose();
        emgStopBuilder_ = null;
      }
      pointStatus_ = null;
      if (pointStatusBuilder_ != null) {
        pointStatusBuilder_.dispose();
        pointStatusBuilder_ = null;
      }
      alrm_ = null;
      if (alrmBuilder_ != null) {
        alrmBuilder_.dispose();
        alrmBuilder_ = null;
      }
      gnSynSt_ = null;
      if (gnSynStBuilder_ != null) {
        gnSynStBuilder_.dispose();
        gnSynStBuilder_ = null;
      }
      gridConnectionState_ = null;
      if (gridConnectionStateBuilder_ != null) {
        gridConnectionStateBuilder_.dispose();
        gridConnectionStateBuilder_ = null;
      }
      manAlrmInfo_ = null;
      if (manAlrmInfoBuilder_ != null) {
        manAlrmInfoBuilder_.dispose();
        manAlrmInfoBuilder_ = null;
      }
      operatingState_ = null;
      if (operatingStateBuilder_ != null) {
        operatingStateBuilder_.dispose();
        operatingStateBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarEventAndStatusZGEN_descriptor;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarEventAndStatusZGEN getDefaultInstanceForType() {
      return openfmb.solarmodule.SolarEventAndStatusZGEN.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarEventAndStatusZGEN build() {
      openfmb.solarmodule.SolarEventAndStatusZGEN result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarEventAndStatusZGEN buildPartial() {
      openfmb.solarmodule.SolarEventAndStatusZGEN result = new openfmb.solarmodule.SolarEventAndStatusZGEN(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.solarmodule.SolarEventAndStatusZGEN result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNodeForEventAndStatus_ = logicalNodeForEventAndStatusBuilder_ == null
            ? logicalNodeForEventAndStatus_
            : logicalNodeForEventAndStatusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.auxPwrSt_ = auxPwrStBuilder_ == null
            ? auxPwrSt_
            : auxPwrStBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.dynamicTest_ = dynamicTestBuilder_ == null
            ? dynamicTest_
            : dynamicTestBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.emgStop_ = emgStopBuilder_ == null
            ? emgStop_
            : emgStopBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.pointStatus_ = pointStatusBuilder_ == null
            ? pointStatus_
            : pointStatusBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.alrm_ = alrmBuilder_ == null
            ? alrm_
            : alrmBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.gnSynSt_ = gnSynStBuilder_ == null
            ? gnSynSt_
            : gnSynStBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000080) != 0)) {
        result.gridConnectionState_ = gridConnectionStateBuilder_ == null
            ? gridConnectionState_
            : gridConnectionStateBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000100) != 0)) {
        result.manAlrmInfo_ = manAlrmInfoBuilder_ == null
            ? manAlrmInfo_
            : manAlrmInfoBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000200) != 0)) {
        result.operatingState_ = operatingStateBuilder_ == null
            ? operatingState_
            : operatingStateBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.solarmodule.SolarEventAndStatusZGEN) {
        return mergeFrom((openfmb.solarmodule.SolarEventAndStatusZGEN)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.solarmodule.SolarEventAndStatusZGEN other) {
      if (other == openfmb.solarmodule.SolarEventAndStatusZGEN.getDefaultInstance()) return this;
      if (other.hasLogicalNodeForEventAndStatus()) {
        mergeLogicalNodeForEventAndStatus(other.getLogicalNodeForEventAndStatus());
      }
      if (other.hasAuxPwrSt()) {
        mergeAuxPwrSt(other.getAuxPwrSt());
      }
      if (other.hasDynamicTest()) {
        mergeDynamicTest(other.getDynamicTest());
      }
      if (other.hasEmgStop()) {
        mergeEmgStop(other.getEmgStop());
      }
      if (other.hasPointStatus()) {
        mergePointStatus(other.getPointStatus());
      }
      if (other.hasAlrm()) {
        mergeAlrm(other.getAlrm());
      }
      if (other.hasGnSynSt()) {
        mergeGnSynSt(other.getGnSynSt());
      }
      if (other.hasGridConnectionState()) {
        mergeGridConnectionState(other.getGridConnectionState());
      }
      if (other.hasManAlrmInfo()) {
        mergeManAlrmInfo(other.getManAlrmInfo());
      }
      if (other.hasOperatingState()) {
        mergeOperatingState(other.getOperatingState());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeForEventAndStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getAuxPwrStFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getDynamicTestFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getEmgStopFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getPointStatusFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getAlrmFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            case 58: {
              input.readMessage(
                  getGnSynStFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000040;
              break;
            } // case 58
            case 66: {
              input.readMessage(
                  getGridConnectionStateFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000080;
              break;
            } // case 66
            case 74: {
              input.readMessage(
                  getManAlrmInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000100;
              break;
            } // case 74
            case 82: {
              input.readMessage(
                  getOperatingStateFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000200;
              break;
            } // case 82
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> logicalNodeForEventAndStatusBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNodeForEventAndStatus field is set.
     */
    public boolean hasLogicalNodeForEventAndStatus() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNodeForEventAndStatus.
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus getLogicalNodeForEventAndStatus() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        return logicalNodeForEventAndStatus_ == null ? openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      } else {
        return logicalNodeForEventAndStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNodeForEventAndStatus_ = value;
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForEventAndStatus(
        openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder builderForValue) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatus_ = builderForValue.build();
      } else {
        logicalNodeForEventAndStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNodeForEventAndStatus(openfmb.commonmodule.LogicalNodeForEventAndStatus value) {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNodeForEventAndStatus_ != null &&
          logicalNodeForEventAndStatus_ != openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance()) {
          getLogicalNodeForEventAndStatusBuilder().mergeFrom(value);
        } else {
          logicalNodeForEventAndStatus_ = value;
        }
      } else {
        logicalNodeForEventAndStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNodeForEventAndStatus() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNodeForEventAndStatus_ = null;
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        logicalNodeForEventAndStatusBuilder_.dispose();
        logicalNodeForEventAndStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder getLogicalNodeForEventAndStatusBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeForEventAndStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder getLogicalNodeForEventAndStatusOrBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ != null) {
        return logicalNodeForEventAndStatusBuilder_.getMessageOrBuilder();
      } else {
        return logicalNodeForEventAndStatus_ == null ?
            openfmb.commonmodule.LogicalNodeForEventAndStatus.getDefaultInstance() : logicalNodeForEventAndStatus_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForEventAndStatus logicalNodeForEventAndStatus = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder> 
        getLogicalNodeForEventAndStatusFieldBuilder() {
      if (logicalNodeForEventAndStatusBuilder_ == null) {
        logicalNodeForEventAndStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNodeForEventAndStatus, openfmb.commonmodule.LogicalNodeForEventAndStatus.Builder, openfmb.commonmodule.LogicalNodeForEventAndStatusOrBuilder>(
                getLogicalNodeForEventAndStatus(),
                getParentForChildren(),
                isClean());
        logicalNodeForEventAndStatus_ = null;
      }
      return logicalNodeForEventAndStatusBuilder_;
    }

    private openfmb.commonmodule.StatusSPS auxPwrSt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> auxPwrStBuilder_;
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     * @return Whether the auxPwrSt field is set.
     */
    public boolean hasAuxPwrSt() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     * @return The auxPwrSt.
     */
    public openfmb.commonmodule.StatusSPS getAuxPwrSt() {
      if (auxPwrStBuilder_ == null) {
        return auxPwrSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
      } else {
        return auxPwrStBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder setAuxPwrSt(openfmb.commonmodule.StatusSPS value) {
      if (auxPwrStBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        auxPwrSt_ = value;
      } else {
        auxPwrStBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder setAuxPwrSt(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (auxPwrStBuilder_ == null) {
        auxPwrSt_ = builderForValue.build();
      } else {
        auxPwrStBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder mergeAuxPwrSt(openfmb.commonmodule.StatusSPS value) {
      if (auxPwrStBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          auxPwrSt_ != null &&
          auxPwrSt_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getAuxPwrStBuilder().mergeFrom(value);
        } else {
          auxPwrSt_ = value;
        }
      } else {
        auxPwrStBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public Builder clearAuxPwrSt() {
      bitField0_ = (bitField0_ & ~0x00000002);
      auxPwrSt_ = null;
      if (auxPwrStBuilder_ != null) {
        auxPwrStBuilder_.dispose();
        auxPwrStBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getAuxPwrStBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getAuxPwrStFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getAuxPwrStOrBuilder() {
      if (auxPwrStBuilder_ != null) {
        return auxPwrStBuilder_.getMessageOrBuilder();
      } else {
        return auxPwrSt_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : auxPwrSt_;
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.StatusSPS AuxPwrSt = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getAuxPwrStFieldBuilder() {
      if (auxPwrStBuilder_ == null) {
        auxPwrStBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getAuxPwrSt(),
                getParentForChildren(),
                isClean());
        auxPwrSt_ = null;
      }
      return auxPwrStBuilder_;
    }

    private openfmb.commonmodule.ENS_DynamicTestKind dynamicTest_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder> dynamicTestBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     * @return Whether the dynamicTest field is set.
     */
    public boolean hasDynamicTest() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     * @return The dynamicTest.
     */
    public openfmb.commonmodule.ENS_DynamicTestKind getDynamicTest() {
      if (dynamicTestBuilder_ == null) {
        return dynamicTest_ == null ? openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
      } else {
        return dynamicTestBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder setDynamicTest(openfmb.commonmodule.ENS_DynamicTestKind value) {
      if (dynamicTestBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        dynamicTest_ = value;
      } else {
        dynamicTestBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder setDynamicTest(
        openfmb.commonmodule.ENS_DynamicTestKind.Builder builderForValue) {
      if (dynamicTestBuilder_ == null) {
        dynamicTest_ = builderForValue.build();
      } else {
        dynamicTestBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder mergeDynamicTest(openfmb.commonmodule.ENS_DynamicTestKind value) {
      if (dynamicTestBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          dynamicTest_ != null &&
          dynamicTest_ != openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance()) {
          getDynamicTestBuilder().mergeFrom(value);
        } else {
          dynamicTest_ = value;
        }
      } else {
        dynamicTestBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public Builder clearDynamicTest() {
      bitField0_ = (bitField0_ & ~0x00000004);
      dynamicTest_ = null;
      if (dynamicTestBuilder_ != null) {
        dynamicTestBuilder_.dispose();
        dynamicTestBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public openfmb.commonmodule.ENS_DynamicTestKind.Builder getDynamicTestBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getDynamicTestFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    public openfmb.commonmodule.ENS_DynamicTestKindOrBuilder getDynamicTestOrBuilder() {
      if (dynamicTestBuilder_ != null) {
        return dynamicTestBuilder_.getMessageOrBuilder();
      } else {
        return dynamicTest_ == null ?
            openfmb.commonmodule.ENS_DynamicTestKind.getDefaultInstance() : dynamicTest_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ENS_DynamicTestKind DynamicTest = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder> 
        getDynamicTestFieldBuilder() {
      if (dynamicTestBuilder_ == null) {
        dynamicTestBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ENS_DynamicTestKind, openfmb.commonmodule.ENS_DynamicTestKind.Builder, openfmb.commonmodule.ENS_DynamicTestKindOrBuilder>(
                getDynamicTest(),
                getParentForChildren(),
                isClean());
        dynamicTest_ = null;
      }
      return dynamicTestBuilder_;
    }

    private openfmb.commonmodule.StatusSPS emgStop_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> emgStopBuilder_;
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     * @return Whether the emgStop field is set.
     */
    public boolean hasEmgStop() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     * @return The emgStop.
     */
    public openfmb.commonmodule.StatusSPS getEmgStop() {
      if (emgStopBuilder_ == null) {
        return emgStop_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
      } else {
        return emgStopBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder setEmgStop(openfmb.commonmodule.StatusSPS value) {
      if (emgStopBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        emgStop_ = value;
      } else {
        emgStopBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder setEmgStop(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (emgStopBuilder_ == null) {
        emgStop_ = builderForValue.build();
      } else {
        emgStopBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder mergeEmgStop(openfmb.commonmodule.StatusSPS value) {
      if (emgStopBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          emgStop_ != null &&
          emgStop_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getEmgStopBuilder().mergeFrom(value);
        } else {
          emgStop_ = value;
        }
      } else {
        emgStopBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public Builder clearEmgStop() {
      bitField0_ = (bitField0_ & ~0x00000008);
      emgStop_ = null;
      if (emgStopBuilder_ != null) {
        emgStopBuilder_.dispose();
        emgStopBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getEmgStopBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getEmgStopFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getEmgStopOrBuilder() {
      if (emgStopBuilder_ != null) {
        return emgStopBuilder_.getMessageOrBuilder();
      } else {
        return emgStop_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : emgStop_;
      }
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS EmgStop = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getEmgStopFieldBuilder() {
      if (emgStopBuilder_ == null) {
        emgStopBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getEmgStop(),
                getParentForChildren(),
                isClean());
        emgStop_ = null;
      }
      return emgStopBuilder_;
    }

    private openfmb.solarmodule.SolarPointStatus pointStatus_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarPointStatus, openfmb.solarmodule.SolarPointStatus.Builder, openfmb.solarmodule.SolarPointStatusOrBuilder> pointStatusBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     * @return Whether the pointStatus field is set.
     */
    public boolean hasPointStatus() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     * @return The pointStatus.
     */
    public openfmb.solarmodule.SolarPointStatus getPointStatus() {
      if (pointStatusBuilder_ == null) {
        return pointStatus_ == null ? openfmb.solarmodule.SolarPointStatus.getDefaultInstance() : pointStatus_;
      } else {
        return pointStatusBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    public Builder setPointStatus(openfmb.solarmodule.SolarPointStatus value) {
      if (pointStatusBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        pointStatus_ = value;
      } else {
        pointStatusBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    public Builder setPointStatus(
        openfmb.solarmodule.SolarPointStatus.Builder builderForValue) {
      if (pointStatusBuilder_ == null) {
        pointStatus_ = builderForValue.build();
      } else {
        pointStatusBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    public Builder mergePointStatus(openfmb.solarmodule.SolarPointStatus value) {
      if (pointStatusBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          pointStatus_ != null &&
          pointStatus_ != openfmb.solarmodule.SolarPointStatus.getDefaultInstance()) {
          getPointStatusBuilder().mergeFrom(value);
        } else {
          pointStatus_ = value;
        }
      } else {
        pointStatusBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    public Builder clearPointStatus() {
      bitField0_ = (bitField0_ & ~0x00000010);
      pointStatus_ = null;
      if (pointStatusBuilder_ != null) {
        pointStatusBuilder_.dispose();
        pointStatusBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    public openfmb.solarmodule.SolarPointStatus.Builder getPointStatusBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getPointStatusFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    public openfmb.solarmodule.SolarPointStatusOrBuilder getPointStatusOrBuilder() {
      if (pointStatusBuilder_ != null) {
        return pointStatusBuilder_.getMessageOrBuilder();
      } else {
        return pointStatus_ == null ?
            openfmb.solarmodule.SolarPointStatus.getDefaultInstance() : pointStatus_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPointStatus PointStatus = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarPointStatus, openfmb.solarmodule.SolarPointStatus.Builder, openfmb.solarmodule.SolarPointStatusOrBuilder> 
        getPointStatusFieldBuilder() {
      if (pointStatusBuilder_ == null) {
        pointStatusBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.solarmodule.SolarPointStatus, openfmb.solarmodule.SolarPointStatus.Builder, openfmb.solarmodule.SolarPointStatusOrBuilder>(
                getPointStatus(),
                getParentForChildren(),
                isClean());
        pointStatus_ = null;
      }
      return pointStatusBuilder_;
    }

    private openfmb.commonmodule.Optional_AlrmKind alrm_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_AlrmKind, openfmb.commonmodule.Optional_AlrmKind.Builder, openfmb.commonmodule.Optional_AlrmKindOrBuilder> alrmBuilder_;
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     * @return Whether the alrm field is set.
     */
    public boolean hasAlrm() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     * @return The alrm.
     */
    public openfmb.commonmodule.Optional_AlrmKind getAlrm() {
      if (alrmBuilder_ == null) {
        return alrm_ == null ? openfmb.commonmodule.Optional_AlrmKind.getDefaultInstance() : alrm_;
      } else {
        return alrmBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    public Builder setAlrm(openfmb.commonmodule.Optional_AlrmKind value) {
      if (alrmBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        alrm_ = value;
      } else {
        alrmBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    public Builder setAlrm(
        openfmb.commonmodule.Optional_AlrmKind.Builder builderForValue) {
      if (alrmBuilder_ == null) {
        alrm_ = builderForValue.build();
      } else {
        alrmBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    public Builder mergeAlrm(openfmb.commonmodule.Optional_AlrmKind value) {
      if (alrmBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          alrm_ != null &&
          alrm_ != openfmb.commonmodule.Optional_AlrmKind.getDefaultInstance()) {
          getAlrmBuilder().mergeFrom(value);
        } else {
          alrm_ = value;
        }
      } else {
        alrmBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    public Builder clearAlrm() {
      bitField0_ = (bitField0_ & ~0x00000020);
      alrm_ = null;
      if (alrmBuilder_ != null) {
        alrmBuilder_.dispose();
        alrmBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    public openfmb.commonmodule.Optional_AlrmKind.Builder getAlrmBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getAlrmFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    public openfmb.commonmodule.Optional_AlrmKindOrBuilder getAlrmOrBuilder() {
      if (alrmBuilder_ != null) {
        return alrmBuilder_.getMessageOrBuilder();
      } else {
        return alrm_ == null ?
            openfmb.commonmodule.Optional_AlrmKind.getDefaultInstance() : alrm_;
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_AlrmKind Alrm = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_AlrmKind, openfmb.commonmodule.Optional_AlrmKind.Builder, openfmb.commonmodule.Optional_AlrmKindOrBuilder> 
        getAlrmFieldBuilder() {
      if (alrmBuilder_ == null) {
        alrmBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_AlrmKind, openfmb.commonmodule.Optional_AlrmKind.Builder, openfmb.commonmodule.Optional_AlrmKindOrBuilder>(
                getAlrm(),
                getParentForChildren(),
                isClean());
        alrm_ = null;
      }
      return alrmBuilder_;
    }

    private openfmb.commonmodule.StatusSPS gnSynSt_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> gnSynStBuilder_;
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     * @return Whether the gnSynSt field is set.
     */
    public boolean hasGnSynSt() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     * @return The gnSynSt.
     */
    public openfmb.commonmodule.StatusSPS getGnSynSt() {
      if (gnSynStBuilder_ == null) {
        return gnSynSt_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
      } else {
        return gnSynStBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    public Builder setGnSynSt(openfmb.commonmodule.StatusSPS value) {
      if (gnSynStBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        gnSynSt_ = value;
      } else {
        gnSynStBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    public Builder setGnSynSt(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (gnSynStBuilder_ == null) {
        gnSynSt_ = builderForValue.build();
      } else {
        gnSynStBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    public Builder mergeGnSynSt(openfmb.commonmodule.StatusSPS value) {
      if (gnSynStBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0) &&
          gnSynSt_ != null &&
          gnSynSt_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getGnSynStBuilder().mergeFrom(value);
        } else {
          gnSynSt_ = value;
        }
      } else {
        gnSynStBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    public Builder clearGnSynSt() {
      bitField0_ = (bitField0_ & ~0x00000040);
      gnSynSt_ = null;
      if (gnSynStBuilder_ != null) {
        gnSynStBuilder_.dispose();
        gnSynStBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getGnSynStBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getGnSynStFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getGnSynStOrBuilder() {
      if (gnSynStBuilder_ != null) {
        return gnSynStBuilder_.getMessageOrBuilder();
      } else {
        return gnSynSt_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : gnSynSt_;
      }
    }
    /**
     * <pre>
     * Emergency stop
     * </pre>
     *
     * <code>.commonmodule.StatusSPS GnSynSt = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getGnSynStFieldBuilder() {
      if (gnSynStBuilder_ == null) {
        gnSynStBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getGnSynSt(),
                getParentForChildren(),
                isClean());
        gnSynSt_ = null;
      }
      return gnSynStBuilder_;
    }

    private openfmb.commonmodule.Optional_GridConnectionStateKind gridConnectionState_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_GridConnectionStateKind, openfmb.commonmodule.Optional_GridConnectionStateKind.Builder, openfmb.commonmodule.Optional_GridConnectionStateKindOrBuilder> gridConnectionStateBuilder_;
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     * @return Whether the gridConnectionState field is set.
     */
    public boolean hasGridConnectionState() {
      return ((bitField0_ & 0x00000080) != 0);
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     * @return The gridConnectionState.
     */
    public openfmb.commonmodule.Optional_GridConnectionStateKind getGridConnectionState() {
      if (gridConnectionStateBuilder_ == null) {
        return gridConnectionState_ == null ? openfmb.commonmodule.Optional_GridConnectionStateKind.getDefaultInstance() : gridConnectionState_;
      } else {
        return gridConnectionStateBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    public Builder setGridConnectionState(openfmb.commonmodule.Optional_GridConnectionStateKind value) {
      if (gridConnectionStateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        gridConnectionState_ = value;
      } else {
        gridConnectionStateBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    public Builder setGridConnectionState(
        openfmb.commonmodule.Optional_GridConnectionStateKind.Builder builderForValue) {
      if (gridConnectionStateBuilder_ == null) {
        gridConnectionState_ = builderForValue.build();
      } else {
        gridConnectionStateBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    public Builder mergeGridConnectionState(openfmb.commonmodule.Optional_GridConnectionStateKind value) {
      if (gridConnectionStateBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0) &&
          gridConnectionState_ != null &&
          gridConnectionState_ != openfmb.commonmodule.Optional_GridConnectionStateKind.getDefaultInstance()) {
          getGridConnectionStateBuilder().mergeFrom(value);
        } else {
          gridConnectionState_ = value;
        }
      } else {
        gridConnectionStateBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000080;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    public Builder clearGridConnectionState() {
      bitField0_ = (bitField0_ & ~0x00000080);
      gridConnectionState_ = null;
      if (gridConnectionStateBuilder_ != null) {
        gridConnectionStateBuilder_.dispose();
        gridConnectionStateBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    public openfmb.commonmodule.Optional_GridConnectionStateKind.Builder getGridConnectionStateBuilder() {
      bitField0_ |= 0x00000080;
      onChanged();
      return getGridConnectionStateFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    public openfmb.commonmodule.Optional_GridConnectionStateKindOrBuilder getGridConnectionStateOrBuilder() {
      if (gridConnectionStateBuilder_ != null) {
        return gridConnectionStateBuilder_.getMessageOrBuilder();
      } else {
        return gridConnectionState_ == null ?
            openfmb.commonmodule.Optional_GridConnectionStateKind.getDefaultInstance() : gridConnectionState_;
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.commonmodule.Optional_GridConnectionStateKind GridConnectionState = 8;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_GridConnectionStateKind, openfmb.commonmodule.Optional_GridConnectionStateKind.Builder, openfmb.commonmodule.Optional_GridConnectionStateKindOrBuilder> 
        getGridConnectionStateFieldBuilder() {
      if (gridConnectionStateBuilder_ == null) {
        gridConnectionStateBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_GridConnectionStateKind, openfmb.commonmodule.Optional_GridConnectionStateKind.Builder, openfmb.commonmodule.Optional_GridConnectionStateKindOrBuilder>(
                getGridConnectionState(),
                getParentForChildren(),
                isClean());
        gridConnectionState_ = null;
      }
      return gridConnectionStateBuilder_;
    }

    private com.google.protobuf.StringValue manAlrmInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> manAlrmInfoBuilder_;
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     * @return Whether the manAlrmInfo field is set.
     */
    public boolean hasManAlrmInfo() {
      return ((bitField0_ & 0x00000100) != 0);
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     * @return The manAlrmInfo.
     */
    public com.google.protobuf.StringValue getManAlrmInfo() {
      if (manAlrmInfoBuilder_ == null) {
        return manAlrmInfo_ == null ? com.google.protobuf.StringValue.getDefaultInstance() : manAlrmInfo_;
      } else {
        return manAlrmInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    public Builder setManAlrmInfo(com.google.protobuf.StringValue value) {
      if (manAlrmInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        manAlrmInfo_ = value;
      } else {
        manAlrmInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    public Builder setManAlrmInfo(
        com.google.protobuf.StringValue.Builder builderForValue) {
      if (manAlrmInfoBuilder_ == null) {
        manAlrmInfo_ = builderForValue.build();
      } else {
        manAlrmInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    public Builder mergeManAlrmInfo(com.google.protobuf.StringValue value) {
      if (manAlrmInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000100) != 0) &&
          manAlrmInfo_ != null &&
          manAlrmInfo_ != com.google.protobuf.StringValue.getDefaultInstance()) {
          getManAlrmInfoBuilder().mergeFrom(value);
        } else {
          manAlrmInfo_ = value;
        }
      } else {
        manAlrmInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000100;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    public Builder clearManAlrmInfo() {
      bitField0_ = (bitField0_ & ~0x00000100);
      manAlrmInfo_ = null;
      if (manAlrmInfoBuilder_ != null) {
        manAlrmInfoBuilder_.dispose();
        manAlrmInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    public com.google.protobuf.StringValue.Builder getManAlrmInfoBuilder() {
      bitField0_ |= 0x00000100;
      onChanged();
      return getManAlrmInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    public com.google.protobuf.StringValueOrBuilder getManAlrmInfoOrBuilder() {
      if (manAlrmInfoBuilder_ != null) {
        return manAlrmInfoBuilder_.getMessageOrBuilder();
      } else {
        return manAlrmInfo_ == null ?
            com.google.protobuf.StringValue.getDefaultInstance() : manAlrmInfo_;
      }
    }
    /**
     * <pre>
     * DC Power On/Off Status; True = DC power on
     * </pre>
     *
     * <code>.google.protobuf.StringValue ManAlrmInfo = 9;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder> 
        getManAlrmInfoFieldBuilder() {
      if (manAlrmInfoBuilder_ == null) {
        manAlrmInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.StringValue, com.google.protobuf.StringValue.Builder, com.google.protobuf.StringValueOrBuilder>(
                getManAlrmInfo(),
                getParentForChildren(),
                isClean());
        manAlrmInfo_ = null;
      }
      return manAlrmInfoBuilder_;
    }

    private openfmb.commonmodule.Optional_OperatingStateKind operatingState_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_OperatingStateKind, openfmb.commonmodule.Optional_OperatingStateKind.Builder, openfmb.commonmodule.Optional_OperatingStateKindOrBuilder> operatingStateBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     * @return Whether the operatingState field is set.
     */
    public boolean hasOperatingState() {
      return ((bitField0_ & 0x00000200) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     * @return The operatingState.
     */
    public openfmb.commonmodule.Optional_OperatingStateKind getOperatingState() {
      if (operatingStateBuilder_ == null) {
        return operatingState_ == null ? openfmb.commonmodule.Optional_OperatingStateKind.getDefaultInstance() : operatingState_;
      } else {
        return operatingStateBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    public Builder setOperatingState(openfmb.commonmodule.Optional_OperatingStateKind value) {
      if (operatingStateBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        operatingState_ = value;
      } else {
        operatingStateBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    public Builder setOperatingState(
        openfmb.commonmodule.Optional_OperatingStateKind.Builder builderForValue) {
      if (operatingStateBuilder_ == null) {
        operatingState_ = builderForValue.build();
      } else {
        operatingStateBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    public Builder mergeOperatingState(openfmb.commonmodule.Optional_OperatingStateKind value) {
      if (operatingStateBuilder_ == null) {
        if (((bitField0_ & 0x00000200) != 0) &&
          operatingState_ != null &&
          operatingState_ != openfmb.commonmodule.Optional_OperatingStateKind.getDefaultInstance()) {
          getOperatingStateBuilder().mergeFrom(value);
        } else {
          operatingState_ = value;
        }
      } else {
        operatingStateBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000200;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    public Builder clearOperatingState() {
      bitField0_ = (bitField0_ & ~0x00000200);
      operatingState_ = null;
      if (operatingStateBuilder_ != null) {
        operatingStateBuilder_.dispose();
        operatingStateBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    public openfmb.commonmodule.Optional_OperatingStateKind.Builder getOperatingStateBuilder() {
      bitField0_ |= 0x00000200;
      onChanged();
      return getOperatingStateFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    public openfmb.commonmodule.Optional_OperatingStateKindOrBuilder getOperatingStateOrBuilder() {
      if (operatingStateBuilder_ != null) {
        return operatingStateBuilder_.getMessageOrBuilder();
      } else {
        return operatingState_ == null ?
            openfmb.commonmodule.Optional_OperatingStateKind.getDefaultInstance() : operatingState_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.Optional_OperatingStateKind OperatingState = 10;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_OperatingStateKind, openfmb.commonmodule.Optional_OperatingStateKind.Builder, openfmb.commonmodule.Optional_OperatingStateKindOrBuilder> 
        getOperatingStateFieldBuilder() {
      if (operatingStateBuilder_ == null) {
        operatingStateBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_OperatingStateKind, openfmb.commonmodule.Optional_OperatingStateKind.Builder, openfmb.commonmodule.Optional_OperatingStateKindOrBuilder>(
                getOperatingState(),
                getParentForChildren(),
                isClean());
        operatingState_ = null;
      }
      return operatingStateBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:solarmodule.SolarEventAndStatusZGEN)
  }

  // @@protoc_insertion_point(class_scope:solarmodule.SolarEventAndStatusZGEN)
  private static final openfmb.solarmodule.SolarEventAndStatusZGEN DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.solarmodule.SolarEventAndStatusZGEN();
  }

  public static openfmb.solarmodule.SolarEventAndStatusZGEN getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SolarEventAndStatusZGEN>
      PARSER = new com.google.protobuf.AbstractParser<SolarEventAndStatusZGEN>() {
    @java.lang.Override
    public SolarEventAndStatusZGEN parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SolarEventAndStatusZGEN> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SolarEventAndStatusZGEN> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.solarmodule.SolarEventAndStatusZGEN getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

